const $ = require('jquery');
require("../css/itemDefectDetail.less");
require('./modal.js');
const {api} = require('./api.js')
const {post,getCookie,getUrlArgObjectNew,emptyBox,downloadExportedData,expJson} = require('./utils.js')
require('./../resource/jquery-ui/jquery-ui.min.js');
require('./../resource/jquery-ui/jquery-ui.min.css');
const iconCheck= require("./../images/icon_check.png")
const iconUnCheck = require("./../images/icon_unchecked.png")
const  iconCalenBlue= require("./../images/icon_calen_blue.png")
const  iconCalenGrey= require("./../images/icon_calen_grey.png")
const iconDown= require("./../images/arrow_down.png")
const iconUp = require("./../images/arrow_up.png")
const loadingImg = require("./../images/loading.gif")
const arrowLeft= require("./../images/arrow_left.png")
const arrowRight = require("./../images/arrow_right.png")

let srcUrl = $("#contentIframe",parent.document).attr("src")
let statisticsType = getUrlArgObjectNew("dateType",srcUrl)||getUrlArgObjectNew("shijian",srcUrl) || ""
let chengdu = getUrlArgObjectNew("chengdu",srcUrl)||""
let deptIdPram = getUrlArgObjectNew("deptId",srcUrl)||""
let deptNamePram = getUrlArgObjectNew("deptName",srcUrl)||""
let docName = getUrlArgObjectNew("docName",srcUrl)||""
let startDateParam =  getUrlArgObjectNew("startDate",srcUrl)||""
let endDateParam =  getUrlArgObjectNew("endDate",srcUrl)||""
let defectName = getUrlArgObjectNew("defectName",srcUrl)||""

$(".selectLevel").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
$(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
let tabList = [], name = "", behospitalCode="", behosDateStart="", level="",behosDateEnd="", scoreSum = 0,
  nameTemp = "", behospitalCodeTemp="",levelTemp="", deptId="",deptIdTemp="",deptName="",deptNameTemp ="", doctorName="", doctorNum="",doctorNameTemp="",doctorNumTemp="",casesEntryName=""
  data_desc=["leaveHospitalDate"],data_asc=[],pageSize = 15,currentPage = 1;
if(chengdu){
    levelTemp = chengdu
    level = chengdu
    $('.selectLevel').html(chengdu)
    $(".levelList").css("display", "none")
    $(".selectLevel").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
}
if(docName){
    doctorNameTemp = docName
    doctorName = docName
    $('.doctorInp').val(docName)
}
if(defectName){
    casesEntryName=defectName
    $('.selectDefect').html(casesEntryName)
}
if(deptIdPram&&deptNamePram){
    deptIdTemp = deptIdPram
    deptId = deptIdPram
    deptName = deptNamePram
    if(deptNamePram.length > 10){
        $('.selectDept').html(deptNamePram.substring(0,8)+'...')
    }else{
        $('.selectDept').html(deptNamePram)
    }
    $('.selectDept ').attr('title',deptNamePram)
    $(".deptList").css("display", "none")
    $(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
}
$('.datapickerBox').append(`<img class="iconCalen" src=${iconCalenGrey} />`)
$('.iconCalen').on("mouseenter", function(e){
    $(this).attr("src", iconCalenBlue)
})
$('.iconCalen').on("mouseleave", function(e){
    $(this).attr("src", iconCalenGrey)
})
$('.iconCalen').on("click", function(e){
    $(this).parent().find("input").focus()
})
$('.recordScoreBtn').css("opacity",hasData('FUNC000017')?'1':'0.5')

$("#filterToggler").click(function(){
    const text = $(this).text();
    $(".toggle-item").slideToggle();
    $(this).text(text==="收起筛选"?"展开筛选":"收起筛选").toggleClass("up");
});
//判断有无某一权限
  function hasData(data){
    let trdObj = JSON.parse(getCookie("trdObj"))
    let lis = trdObj['YH-BLZK-ZKPF']
    if(!lis){
      return false
    }
    if(lis.indexOf(data)>-1){//有权限
        return true
    }
    return false;
}
function getTabData(activePage){
    const param = {
        current:activePage,
        behospitalCode: behospitalCode,
        patName: name, //病人姓名
        level:level,//病历等级
        behDeptName: deptName,
        ascs:data_asc,     //升序
        descs:data_desc,       //降序
        startDate: behosDateStart, //出院日期--开始时间
        endDate: behosDateEnd, //出院日期--结束时间
        casesEntryName: casesEntryName,
        size: pageSize,
    }
    post(api.qcResultDefectList,param).then(res =>{
        if(res.data.code == '0'){
            const data = res.data.data;
            currentPage = data.current;
            tabList = data.records;
            const totalPage = data.pages;
            const totalNum = data.total;
            renderTab(tabList,data.hospitalId);
            renderPagination(totalPage,Number(activePage),totalNum)
            if(totalPage > 1){
                renderPagination(totalPage,Number(activePage),totalNum)
            } else{
                $('.pagination').html("")
            }
        }else{
            $.alerModal({"message":res.data.msg,type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
        }
    }).catch((e) =>{
    
    })
}

//getTabData(1)

$(".filter").on("click", function(e){
    behosDateStart = $("#datepicker").val().trim()
    behosDateEnd = $("#datepicker2").val().trim()
    const start = new Date(behosDateStart).getTime()
    const end = new Date(behosDateEnd).getTime()
    if(start > end){
        $.alerModal({"message":'开始时间不能大于结束时间~',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
        return
    }
    if(behosDateStart){
        behosDateStart = behosDateStart.replace(/\//g,'-') + ' 00:00:00'
    }
    if(behosDateEnd){
        behosDateEnd = behosDateEnd.replace(/\//g,'-') + ' 23:59:59'
    }
    console.log('deptNameTemp',deptNameTemp)
    name = nameTemp
    behospitalCode = behospitalCodeTemp
    level = levelTemp==="全部"?"":levelTemp
    deptId = deptIdTemp
    deptName = deptNameTemp==="全部"?"":deptNameTemp 
    doctorName = doctorNameTemp
    doctorNum = doctorNumTemp
    getTabData(1)
})
$(".abnormalClear").on("click", function(e){
    tabList = []; 
    name = ""; 
    behospitalCode="";  
    level=""; 
    scoreSum = 0; 
    nameTemp = "";  
    behospitalCodeTemp=""; 
    levelTemp="";  
    deptId=""; 
    deptIdTemp="";  
    deptName="";
    deptNameTmp="";
    doctorName=""; 
    doctorNum=""; 
    doctorNameTemp=""; 
    doctorNumTemp=""; 
    data_desc=[]; 
    data_asc=[];
    $('.patientNumInp').val('')
    $('.patientNameInp').val('')
    $('.doctorInp').val('')
    $('.doctorNumInp').val('')
    $('.doctorInp').val('')
    // $('#datepicker').val('')
    // $('#datepicker2').val('')
    //默认日期为近一个月
    $( "#datepicker" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy/mm/dd",
    }).datepicker( "setDate", "-6d");
    $( "#datepicker2" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy/mm/dd"
    }).datepicker( "setDate",new Date());
    $('.selectDept ').html('全部')
    $(".deptList").css("display", "none")
    $(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
    // $('.selectDept ').addClass('unSelect')
    $('.selectLevel').html('全部')
    $(".levelList").css("display", "none")
    $(".selectLevel").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
    // $('.selectLevel ').addClass('unSelect')
    $("th[code]").removeClass("asc desc")
    behosDateStart = $("#datepicker").val().trim()
    behosDateEnd = $("#datepicker2").val().trim()
    if(behosDateStart){
        behosDateStart = behosDateStart.replace(/\//g,'-') + ' 00:00:00'
    }
    if(behosDateEnd){
        behosDateEnd = behosDateEnd.replace(/\//g,'-') + ' 23:59:59'
    }
   
    getTabData(1)
})
function renderTab(data,hisId){
    let str = ``
    let hasSelectAll = true;
    if(data.length===0){
      $('tbody').html(emptyBox())
      return;
    }
    for(let i = 0; i < data.length; i++){
        const item = data[i]
        if(!item.hasSelect){
            hasSelectAll = false
        }
        str += `
            <tr  data-index=${i}>
                <td class="textCenter">${pageSize * (currentPage-1) + i + 1}</td>
                <td >${item.behospitalCode || "-"}</td>
                <td  class="textCenter">${item.level || "-"}</td>
                <td  class="textCenter">${item.scoreRes || "-"}</td>
                <td  class="textCenter"><span data-index=${i} class="patientNameSpan">${item.patName || "-"}<span></td>
                <td  class="textCenter">${item.sex || "-"}</td>
                <td  class="textCenter">${item.age || "-"}</td>
                <td  class="textCenter">${item.behDeptName || "-"}</td>
                <td  class="textCenter">${item.leaveHospitalDate&&item.leaveHospitalDate.slice(0,10)|| "-"}</td>
            </tr>
        `
    }
    if(data.length === 0){
        hasSelectAll = false
    }
    if(hasSelectAll){
        $('.scoreOpera img').attr("src" ,iconCheck)
        $('.scoreOpera').attr("data-selectall",true)
    }else{
        $('.scoreOpera img').attr("src" ,iconUnCheck)
        $('.scoreOpera').attr("data-selectall",false)
    }
    $('tbody').html(str)
    bindScoreOperaItem()
    bindRecordScoreOper()
    bindScoreDetail(hisId)
}

function scoreDetail(id,age,hid,code,name){
    window.open(`./qcScore.html?id=${id}&age=${age}&name=${name}&hid=${getCookie('hospitalid')}&code=${code}`)
}
function bindScoreDetail(hisId){
    $('.patientNameSpan').on('click',function(e){
        const index = $(this).attr("data-index")
        const id = tabList[index].behospitalCode
        const age = tabList[index].age;
        const noScore = tabList[index].level == '未评分'
        if(noScore){
            $.alerModal({"message":'请先进行评分！',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
            return
        } else{
            scoreDetail(id,age,hisId,'YH-BLZK-ZKPF',tabList[index].patName)
        }
       
    })
}

//选择病历等级
$('.selectLevel').on("click", function(e){
    e.stopPropagation()
    $(".deptList ").css("display", "none")
    $(".selectDept .arrow").attr("src",iconDown)
    const showList =  $(".levelList ").css("display")
    if(showList == "none" ||!showList){
        $(".levelList ").css("display","block")
        $(".selectLevel .arrow").attr("src",iconUp)
    }else{
        $(".levelList ").css("display", "none")
        $(".selectLevel .arrow").attr("src",iconDown)
    }
})

bindLeveldSelect()
//是否启用选择
function bindLeveldSelect(){
    $('.levelItem').on("click",function(){
        const levelItemName = $(this).attr("data-name")
        const levelItemItemId = $(this).attr("data-id")
        levelTemp =levelItemItemId
        $('.selectLevel').html(levelItemName)
        $(".levelList").css("display", "none")
        $(".selectLevel").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
        $('.selectLevel').removeClass('unSelect')
    })
}

//全选绑定
bindOperaAll()
function bindScoreOperaItem(){
    $(".scoreOperaItem").on("click",  function(e){
        const index = $(this).parent().attr("data-index")
        tabList[index].hasSelect = tabList[index].hasSelect ? false:true
        renderTab(tabList)
    })
}
function bindRecordScoreOper(){
    $(".recordScoreOperaBtn").on("click",  function(e){
        if(!hasData('FUNC000017')){
            return
        }
        const index = $(this).parent().attr("data-index")
        const behospitalCode = tabList[index].behospitalCode
        loading()
        recordScore(behospitalCode,1,true)
    })
}
function bindOperaAll(){
    $('.scoreOpera').on("click", function(e){
        const hasSelectAll = $('.scoreOpera').attr("data-selectall")
        if(hasSelectAll == 'true'){

            for(let i = 0; i < tabList.length; i++){
                tabList[i].hasSelect = false
            }
        }else{
            for(let i = 0; i < tabList.length; i++){
                tabList[i].hasSelect = true
            }
        }
        renderTab(tabList)
    })
}

$('.selectDept').on("click", function(e){
    e.stopPropagation()
    $(".levelList ").css("display","none")
    $(".selectLevel .arrow").attr("src",iconDown)
    const showList =  $(".deptList ").css("display")
    if(showList == "none" ||!showList){
        $(".deptList ").css("display","block")
        $(".selectDept .arrow").attr("src",iconUp)
    }else{
        $(".deptList ").css("display", "none")
        $(".selectDept .arrow").attr("src",iconDown)
    }
})

//获取科室列表
getDeptList()
function getDeptList(){
    post(api.getDeptList,{inputStr:""}).then(res =>{
        if(res.data.code == '0'){
           const  deptList = res.data.data
           rendeDeptList(deptList)
        }else{}
    }).catch((e) =>{

    })
}


function rendeDeptList(deptList){
    let str = `<li class="deptItem ellipsis" data-id=" " data-name="全部">全部</li>`;
    for(let i = 0; i < deptList.length; i++){
        str += `<li class="deptItem ellipsis" title=${deptList[i].deptName} data-id=${deptList[i].deptId} data-name=${deptList[i].deptName}> ${deptList[i].deptName}</li>`
    }
    $('.deptList').html(str)
    bindDeptSelect()
}
//科室选择
function bindDeptSelect(){
    $('.deptItem').on("click",function(){
        const deptItemName = $(this).attr("data-name")
        const deptItemId = $(this).attr("data-id")
        deptIdTemp =deptItemId
        deptNameTemp = deptItemName
        if(deptItemName.length > 10){
            $('.selectDept').html(deptItemName.substring(0,8)+'...')
        }else{
            $('.selectDept').html(deptItemName)
        }
        $('.selectDept ').attr('title',deptItemName)
        $(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
        $(".deptList").css("display", "none")
        $('.selectDept').removeClass('unSelect')
    })
}
function loading(){
    const str = `
    <div class="loadingBox">
            <div class="mask"></div>
            <img class="loadingImg" src=${loadingImg}  alt="loading" />
        </div>
    `
    $("#mainBox", parent.document).append(str)
}
function hideLoading(){
    $("#mainBox .loadingBox", parent.document).remove()
}
$('.recordScoreBtn').on("click",function(e){
    if(!hasData('FUNC000017')){
        return
    }
    let scoreList = []
    for(let i = 0; i <tabList.length; i++){
        if(tabList[i].hasSelect){
            scoreList.push(tabList[i].behospitalCode)
        }
    }
    if(scoreList.length === 0){
        $.alerModal({"message":'请选择要评分的项！',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
        return
    } else{
        loading()
        for(let j = 0; j < scoreList.length; j++){
            recordScore(scoreList[j],scoreList.length,true)
        }
    }
})
$("th[code]").on("click",function(e){
    const code=$(this).attr("code");
    if(data_asc[0]===code){
      data_desc=[code];
      data_asc=[];
      $("th[code]").removeClass("asc desc");
      $(this).addClass("desc");
    }else{
      data_desc=[];
      data_asc=[code];
      $("th[code]").removeClass("asc desc");
      $(this).addClass("asc");
    }
    getTabData(1);
    // console.log(code)
});
function recordScore(behospitalCode,totalNum,hasToast){
    const param = {
        behospitalCode: behospitalCode
    }
    post(api.recordScore,param).then(res =>{
        if(res.data.code == '0'){
            scoreSum++
            if(scoreSum === totalNum){
                hideLoading()
                scoreSum = 0
                const activePage = $(".activePage").attr('data-page') || 1

                getTabData(activePage)
                if(hasToast){
                  $.alerModal({"message":'评分成功',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
                }
            }
            
        }else{
            hideLoading()
            if(hasToast){
                $.alerModal({"message":'评分失败',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
            }
        }
    }).catch((e) =>{
        hideLoading()
        if(hasToast){
            $.alerModal({"message":'评分失败',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
        }
    })
}
$(".patientNumInp").on("input", function(e){
    const val = $(this).val().trim()
    behospitalCodeTemp = val
})
$(".patientNameInp").on("input", function(e){
    const val = $(this).val().trim()
    nameTemp = val
})
$(".doctorInp").on("input", function(e){
    const val = $(this).val().trim()
    doctorNameTemp = val
})
$(".doctorNumInp").on("input", function(e){
  const val = $(this).val().trim();
    doctorNumTemp = val
})
$(function() {
    $.datepicker.regional['zh-CN'] = {
    clearText: '清除',
    clearStatus: '清除已选e799bee5baa6e59b9ee7ad9431333361303131日期',
    closeText: '关闭',
    closeStatus: '不改变当前选择',
    prevText: '<上月',
    prevStatus: '显示上月',
    prevBigText: '<<',
    prevBigStatus: '显示上一年',
    nextText: '下月>',
    nextStatus: '显示下月',
    nextBigText: '>>',
    nextBigStatus: '显示下一年',
    currentText: '今天',
    currentStatus: '显示本月',
    monthNames: ['一月','二月','三月','四月','五月','六月', '七月','八月','九月','十月','十一月','十二月'],
    monthNamesShort: ['一月','二月','三月','四月','五月','六月', '七月','八月','九月','十月','十一月','十二月'],
    yearNamesShort: ['一月','二月','三月','四月','五月','六月', '七月','八月','九月','十月','十一月','十二月'],
    monthStatus: '选择月份',
    yearStatus: '选择年份',
    weekHeader: '周',
    weekStatus: '年内周次',
    dayNames: ['星期日','星期一','星期二','星期三','星期四','星期五','星期六'],
    dayNamesShort: ['周日','周一','周二','周三','周四','周五','周六'],
    dayNamesMin: ['日','一','二','三','四','五','六'],
    dayStatus: '设置 DD 为一周起始',
    dateStatus: '选择 m月 d日, DD',
    dateFormat: 'yy-mm-dd',
    firstDay: 1,
    initStatus: '请选择日期',
    isRTL: false};
    $.datepicker.setDefaults($.datepicker.regional['zh-CN']);
    let startDate = "", endDate=new Date()
    let year = new Date().getFullYear()
    let month = new Date().getMonth() + 1
    if(statisticsType == '1'){
        startDate = new Date(`${year}-${month}-01`)
    }else if(statisticsType == '2'){
        startDate = new Date(`${year}-01-01`)
    } else {
        startDate =new Date(startDateParam)
        endDate = new Date(endDateParam) || new Date()
    }
    $( "#datepicker" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy/mm/dd",
    }).datepicker( "setDate", startDate);
    $( "#datepicker2" ).datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat:"yy/mm/dd"
    }).datepicker( "setDate",endDate);
    $(".filter").click();   //初始查询
    $(".partTitle .titlePic ").html(`<a class="consoleD" href="console.html">控制台 / </a><a class="consoleP" href="singleVeto.html?form=1">条目缺陷占比 / </a>缺陷详情`)
    $(".partTitle .consoleD").click(function(){
        $(".menu .page",parent.document).removeClass("active").eq(0).addClass("active");
        $(".container",parent.document).addClass("console-cont");
    })
    $(".partTitle .consoleP").click(function(){
        $(parent.document).find("#contentIframe").attr("src",`./singleVeto.html?from=1`)
       
    })
});

//分页渲染
function renderPagination(totalPage,activePage,totalNum){
    let str = `<span class="totalSum">共${totalPage}页/${totalNum}条数据</span><span class="prePage"><img class="arrowPage" src=${arrowLeft} /></span>`
    if(totalPage <= 6){
        for(let i = 1; i <= totalPage; i++){
          
            str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
        }
    }else{
        if(activePage <= 3){ //选中页数小于4
            for(let i = 1; i <= 4; i++){
                str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
            }
            str += `<span class="more" >...</span>`
        str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`

        } else if(activePage > totalPage -3){
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+(totalPage-3)}" data-page=${totalPage -3}>${totalPage -3}</span>`
            str += `<span class="pageNum ${'page'+(totalPage-2)}" data-page=${totalPage -2}>${totalPage -2}</span>`
            str += `<span class="pageNum ${'page'+(totalPage-1)}" data-page=${totalPage -1}>${totalPage -1}</span>`
            str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
        } else {
            str += `<span class="pageNum page1" data-page=1>1</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+(activePage -1)}" data-page=${activePage -1}>${activePage -1}</span>`
            str += `<span class="pageNum ${'page'+activePage}" data-page=${activePage}>${activePage}</span>`
            str += `<span class="pageNum ${'page'+(activePage +1)}" data-page=${activePage +1}>${activePage +1}</span>`
            str += `<span class="more" >...</span>`
            str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
        }
       
    }
    str += `<span class="nextPage"><img class="arrowPage" src=${arrowRight} /></span>`
    $('.pagination').html(str)
    $('.page' + activePage).addClass('activePage')
    $(".pageNum").on("click", function(e){
        const activePageNow = Number($(this).attr('data-page'))
        getTabData(activePageNow)
        // renderPagination(totalPage,activePageNow,totalNum)
    })
    $(".prePage").on("click", function(e){
        let activePageNow = Number($(".activePage").attr('data-page'))
        if(activePageNow > 1){
            activePageNow--
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })
    $(".nextPage").on("click", function(e){
        let activePageNow = Number($(".activePage").attr('data-page'))
        if(activePageNow < totalPage){
            activePageNow++
            getTabData(activePageNow)
            // renderPagination(totalPage,activePageNow,totalNum)
        }
    })
    
}

$(document).on("click", function(){
    $(".levelList ").css("display", "none")
    $(".deptList").css("display", "none")
    $(".selectLevel .arrow").attr("src",iconDown)
    
})
$((function($){

    $('.export').click(function(){
        if((new Date(behosDateEnd) - new Date(behosDateStart))/24/60/60/1000 > 7){
            $.alerModal({"message":"最多只能导出7天",type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
            return
        }
        const param = {
            "behospitalCode": behospitalCode,
            "deptId": deptId,
            "doctorCode":doctorNum,
            "doctorName": doctorName,
            "leaveHosDateEnd": '2020-04-03 00:00:00'||behosDateEnd,
            "leaveHosDateStart": '2020-04-01 00:00:00'||behosDateStart,
            "level": 2||level,
            "name": name
        }
        expJson(api.exportQcList,param).then(res =>{
            downloadExportedData(res.data, behosDateStart.slice(0,10).replace(/-/g,"")+"-"+behosDateEnd.slice(0,10).replace(/-/g,"")+"抽查住院病历质量情况.xls")
        })
      
    })
})($));